package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRFamily;
import cn.ibizlab.humanresource.core.humanresource.filter.HRFamilySearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRFamily] 服务对象接口
 */
public interface IHRFamilyService extends IService<HRFamily>{

    boolean create(HRFamily et) ;
    void createBatch(List<HRFamily> list) ;
    boolean update(HRFamily et) ;
    void updateBatch(List<HRFamily> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRFamily get(String key) ;
    HRFamily getDraft(HRFamily et) ;
    boolean checkKey(HRFamily et) ;
    boolean save(HRFamily et) ;
    void saveBatch(List<HRFamily> list) ;
    Page<HRFamily> searchDefault(HRFamilySearchContext context) ;
    List<HRFamily> selectByHremployeeid(String employeeid) ;
    void removeByHremployeeid(String employeeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRFamily> getHrfamilyByIds(List<String> ids) ;
    List<HRFamily> getHrfamilyByEntities(List<HRFamily> entities) ;
}


